/*
  TEST.CPP
  Used to make a stand-alone .EXE (for debugging)


  Copyright (c) 1994 by Borland International
  All Rights Reserved

  This source code is hereby released into the public domain.
  Written by Jeffrey J. Peters

*/

#include <windows.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "uiclass.h"

extern "C" void UIStart (unsigned short, unsigned long);
#define DEBUGFILE "tdusrtst.log"
FILE *log = 0;
int log_memory = 1;

void MouseInit (void)
{
  #ifdef __DPMI32__
    _EAX = 0;
  #endif
    _AX = 0;
    geninterrupt (0x33);

  #ifdef __DPMI32__
    _EAX = 0;
  #endif
    _AX = 1;
    geninterrupt (0x33);

  #ifdef __DPMI32__
    _EAX = _ECX = _EDX = 0;
  #endif
    _AX = 4;
    _CX = 0;
    _DX = 0;
    geninterrupt (0x33);
}

void MouseDone (void)
{
  #ifdef __DPMI32__
    _EAX = 0;
  #endif
    _AX = 0;
    geninterrupt (0x33);

  #ifdef __DPMI32__
    _EAX = 0;
  #endif
    _AX = 2;
    geninterrupt (0x33);
}

static bits16 GetScreenSel (bits16 seg);

#pragma argsused
int main (int argc, char *argv[])
{
  unsigned long data = 0;
  MouseInit ();

  log = fopen (DEBUGFILE, "wt");
  if (log == 0)
  {
    perror (DEBUGFILE);
    return 0;
  }

  #ifdef __DPMI32__
    data = (unsigned long) GetCurrentProcess ();
    UIStart (0, data);
  #else
  if (argc >=2)
    UIStart (GetScreenSel (0xB000), data);
  else
    UIStart (GetScreenSel (0xB800), data);
  #endif
  MouseDone ();
  return 0;
}

static bits16 GetScreenSel (bits16 seg)
{
  _AX = 2;
  _BX = seg;
  geninterrupt (0x31);
  return _AX;
}

int EvalExpr (char *str, char *result)
{
  unsigned long d;
  if (stricmp (str, "color") == 0)
    d = GetScreenSel (0xB800);
  else
  if (stricmp (str, "mono") == 0)
    d = GetScreenSel (0xB000);
  else
    d = strtoul (str, 0, 16);  // hex
  sprintf (result, "unsigned int %lu (0x%lX)", d, d);
  return 1;
}
