/*
  UIMOV.CPP
  Main source file for class UIMove


  Copyright (c) 1994 by Borland International
  All Rights Reserved

  This source code is hereby released into the public domain.
  Written by Jeffrey J. Peters

*/

#include "uiclass.h"

UIMove::UIMove (UIWindow &w) : UIWindow (), parent (w)
{
  UIRect &r = w.rFrame;
  title = newStr (" Move ");
  rFrame = r;
  rWindow = r;
  rWindow.lr -= UIPoint (2,1);
  rWindow += UIRect (1, 1, -1, -1);
  UISave ();
  uiFlags = w.uiFlags | UIFNoClearScreen | UIFNoCursorFix;
  bgfgBorder = (w.bgfgBorder & 0xF0) | LIGHTGREEN;

  minw = w.MinWidth ();
  minh = w.MinHeight ();

  DrawBox (uiFlags, bgfgScreen, bgfgBorder);
}

#pragma warn -rlv
int UIMove::Move ()
{
  while (1)
  {
    while (UIObject::BIOSKeyWaiting ())
      UIObject::GetBIOSKey ();

    switch (UIObject::GetBIOSKey ())
    {
      case K_F1:
        {
          UIMsgBox (
          " <Esc>         - use old size & location\r\n"
          " <F5>          - zooms the screen\r\n"
          " <Up>,<Down>   - move window\r\n"
          " <Shift-Up>,   \r\n"
          " <Shift-Dwn>   - resize window\r\n"
          " <Enter>       - accept new size & location"
          ,  " Move/Re-size Help " ,6, 50);
        }
        break;

      case K_ESC:
      case K_ALT_F3:
        return 0;

      case K_ENTER:
        return 1;

      case K_LEFT:
          SlideOver (1);
        break;
      case K_RIGHT:
          SlideOver (2);
        break;
      case K_UP:
          SlideOver (3);
        break;
      case K_DOWN:
          SlideOver (4);
        break;

      case K_SHIFT_LEFT:
          Stretch (2);
        break;
      case K_SHIFT_RIGHT:
          Stretch (-2);
        break;
      case K_SHIFT_UP:
          Stretch (-4);
        break;
      case K_SHIFT_DOWN:
          Stretch (4);
        break;

      case K_F5:
          Zoom (!IsZoomed());
        break;
      case K_CTRL_F5:
          return 1;
    }
  }
}